Typedefs | Functions

# splay-tree.h File Reference

Go to the source code of this file.

## Typedefs
typedef struct _SplayTreeInfo | SplayTreeInfo
## Functions
WizardExport const void * | GetNextKeyInSplayTree (SplayTreeInfo *)
WizardExport const void ** | GetNextValueInSplayTree (SplayTreeInfo *)
WizardExport const void *** | GetValueFromSplayTree (SplayTreeInfo *, const void *)
WizardExport int | CompareSplayTreeString (const void *, const void *)
WizardExport int | CompareSplayTreeStringInfo (const void *, const void *)
WizardExport SplayTreeInfo * | CloneSplayTree (SplayTreeInfo *, void *(*)(void *), void *(*)(void *))
WizardExport SplayTreeInfo ** | DestroySplayTree (SplayTreeInfo *)
WizardExport SplayTreeInfo *** | NewSplayTree (int(*)(const void *, const void *), void *(*)(void *), void *(*)(void *))
WizardExport size_t | GetNumberOfNodesInSplayTree (const SplayTreeInfo *)
WizardExport void * | RemoveNodeByValueFromSplayTree (SplayTreeInfo *, const void *)
WizardExport void ** | RemoveNodeFromSplayTree (SplayTreeInfo *, const void *)
WizardExport void ** | ResetSplayTree (SplayTreeInfo *)
WizardExport void ** | ResetSplayTreeIterator (SplayTreeInfo *)
WizardExport WizardBooleanType | AddValueToSplayTree (SplayTreeInfo *, const void *, const void *)
WizardExport WizardBooleanType | DeleteNodeByValueFromSplayTree (SplayTreeInfo *, const void *)
WizardExport WizardBooleanType | DeleteNodeFromSplayTree (SplayTreeInfo *, const void *)

## Typedef Documentation

typedef struct _SplayTreeInfo SplayTreeInfo

## Function Documentation

WizardExport WizardBooleanType AddValueToSplayTree | ( | SplayTreeInfo * | ,
|  | const void * | ,
|  | const void * |  |
| ) |  |  |

WizardExport SplayTreeInfo* CloneSplayTree | ( | SplayTreeInfo * | ,
|  | void * | *)(void *,
|  | void * | *)(void * |
| ) |  |  |

WizardExport int CompareSplayTreeString | ( | const void * | ,
|  | const void * |  |
| ) |  |  |

WizardExport int CompareSplayTreeStringInfo | ( | const void * | ,
|  | const void * |  |
| ) |  |  |

References CompareStringInfo().

Referenced by AcquireKeyInfo().

WizardExport WizardBooleanType DeleteNodeByValueFromSplayTree | ( | SplayTreeInfo * | ,
|  | const void * |  |
| ) |  |  |

WizardExport WizardBooleanType DeleteNodeFromSplayTree | ( | SplayTreeInfo * | ,
|  | const void * |  |
| ) |  |  |

References _SplayTreeInfo::compare, _SplayTreeInfo::debug, GetWizardModule, _NodeInfo::key, _SplayTreeInfo::key, _NodeInfo::left, LockSemaphoreInfo(), LogWizardEvent(), _SplayTreeInfo::nodes, _SplayTreeInfo::relinquish_key, _SplayTreeInfo::relinquish_value, RelinquishWizardMemory(), ResourceDomain, _NodeInfo::right, _SplayTreeInfo::root, _SplayTreeInfo::semaphore, _SplayTreeInfo::signature, SplaySplayTree(), TraceEvent, UnlockSemaphoreInfo(), _NodeInfo::value, WizardAssert, WizardFalse, WizardSignature, and WizardTrue.

Referenced by RelinquishUniqueFileResource().

WizardExport SplayTreeInfo* * DestroySplayTree | ( | SplayTreeInfo * |  | ) |

WizardExport const void* GetNextKeyInSplayTree | ( | SplayTreeInfo * |  | ) |

WizardExport const void* * GetNextValueInSplayTree | ( | SplayTreeInfo * |  | ) |

WizardExport size_t GetNumberOfNodesInSplayTree | ( | const SplayTreeInfo * |  | ) |

References _SplayTreeInfo::debug, GetWizardModule, LogWizardEvent(), _SplayTreeInfo::nodes, ResourceDomain, _SplayTreeInfo::signature, TraceEvent, WizardAssert, WizardFalse, and WizardSignature.

WizardExport const void* * * GetValueFromSplayTree | ( | SplayTreeInfo * | ,
|  | const void * |  |
| ) |  |  |

References _SplayTreeInfo::compare, _SplayTreeInfo::debug, GetWizardModule, _NodeInfo::key, LockSemaphoreInfo(), LogWizardEvent(), ResourceDomain, _SplayTreeInfo::root, _SplayTreeInfo::semaphore, _SplayTreeInfo::signature, SplaySplayTree(), TraceEvent, UnlockSemaphoreInfo(), _NodeInfo::value, WizardAssert, WizardFalse, and WizardSignature.

Referenced by GetKeyInfo(), and SetKeyInfo().

WizardExport SplayTreeInfo* * * NewSplayTree | ( | int(*)(const void *, const void *) | ,
|  | void * | *)(void *,
|  | void * | *)(void * |
| ) |  |  |

WizardExport void* RemoveNodeByValueFromSplayTree | ( | SplayTreeInfo * | ,
|  | const void * |  |
| ) |  |  |

WizardExport void* * RemoveNodeFromSplayTree | ( | SplayTreeInfo * | ,
|  | const void * |  |
| ) |  |  |

WizardExport void* * ResetSplayTree | ( | SplayTreeInfo * |  | ) |

WizardExport void* * ResetSplayTreeIterator | ( | SplayTreeInfo * |  | ) |

References _SplayTreeInfo::debug, GetFirstSplayTreeNode(), GetWizardModule, LockSemaphoreInfo(), LogWizardEvent(), _SplayTreeInfo::next, ResourceDomain, _SplayTreeInfo::semaphore, _SplayTreeInfo::signature, TraceEvent, UnlockSemaphoreInfo(), WizardAssert, WizardFalse, and WizardSignature.

Referenced by AsynchronousResourceComponentTerminus(), and RelinquishUniqueFileResource().